#!/usr/bin/env node
import c from "prompts";
import { join as g, basename as V } from "node:path";
import { existsSync as o, readFileSync as P, mkdirSync as u, writeFileSync as i, appendFileSync as F, rmSync as x, statSync as v, readdirSync as $ } from "node:fs";
import m from "chalk";
import T from "lodash.upperfirst";
import S from "lodash.camelcase";
import A from "lodash.kebabcase";
import N from "lodash.template";
import _ from "lodash.get";
import b from "lodash.lowerfirst";
import R from "json5";
import { resolveTemplate as D } from "./template.js";
import { rootPath as d, configPath as k } from "./path.config.js";
const j = () => {
  let n;
  const r = g(d, k);
  if (o(r)) {
    const l = P(r, "utf-8");
    n = R.parse(l);
  }
  if (!n)
    throw new Error("配置文件不存在");
  return n;
}, I = async (n) => {
  const r = (n == null ? void 0 : n.series) || (await c({
    type: "text",
    name: "series",
    message: "请输入组件系列前缀",
    validate: (l) => l ? !0 : "组件系列前缀不能为空"
  })).series;
  if (!r)
    throw new Error("组件系列前缀不能为空");
  return r;
}, L = async (n) => {
  const r = (n == null ? void 0 : n.src) || (await c({
    type: "text",
    name: "src",
    message: "请输入组件源码路径",
    initial: "src",
    validate: (l) => l ? !0 : "组件源码路径不能为空"
  })).src;
  if (!r)
    throw new Error("组件源码路径不能为空");
  return r;
}, q = ({
  src: n,
  entryAbsoluteSrc: r,
  entryTemplate: l
}) => {
  const a = g(d, n), p = v(a);
  let e = "";
  if (o(r) && (e = P(r, "utf-8") || ""), !e)
    throw new Error("没有可以删除的文件");
  if (p.isDirectory()) {
    const y = $(a), t = N(l), E = y.map((f) => {
      const h = g(a, f);
      return v(h).isDirectory() ? V(h) : "";
    }).filter((f) => {
      if (!f)
        return !1;
      const h = C({ name: f }), w = t({
        ...h,
        src: n,
        nameLowerFirst: b(h.name)
      });
      return e.includes(w);
    });
    if (E.length === 0)
      throw new Error("组件列表为空");
    return E;
  } else
    throw new Error("组件源码路径不是目录");
}, C = ({
  name: n,
  series: r
}) => {
  const l = T(S(n)), a = r ? T(S(r)) : "", p = r ? `${a}${l}` : "", e = r ? A(p) : "", y = A(n);
  return {
    series: a,
    name: l,
    full: p,
    cls: e,
    dir: y
  };
}, z = async ({
  argv: n,
  configInfo: r
}) => {
  const l = await I(r), a = n.name || (await c({
    type: "text",
    name: "name",
    message: "请输入组件名称",
    validate: (y) => y ? !0 : "组件名称不能为空"
  })).name;
  if (!a)
    throw new Error("组件名称不能为空");
  const p = C({
    name: a,
    series: l
  });
  console.log(p);
  const e = D(
    r,
    {
      ...p,
      rootPath: d
    },
    [
      "component.dir",
      "component.templateFilePath",
      "component.fileName",
      "component.entryTemplate",
      "component.entryPath",
      "type.dir",
      "type.templateFilePath",
      "type.fileName",
      "type.entryTemplate",
      "type.entryPath",
      "style.dir",
      "style.templateFilePath",
      "style.fileName",
      "style.varTemplate",
      "style.varPath",
      "style.entryTemplate",
      "style.entryPath",
      "example.dir",
      "example.templateFilePath",
      "example.fileName",
      "example.entryTemplate",
      "example.entryPath"
    ]
  );
  if (console.log(e), o(e.componentFilePath))
    throw new Error("组件已存在");
  if (o(e.typeFilePath))
    throw new Error("类型已存在");
  if (o(e.styleFilePath))
    throw new Error("样式已存在");
  if (o(e.exampleFilePath))
    throw new Error("示例已存在");
  u(e.componentDirPath, { recursive: !0 }), i(e.componentFilePath, e.componentFileContent), u(e.typeDirPath, { recursive: !0 }), i(e.typeFilePath, e.typeFileContent), u(e.styleDirPath, { recursive: !0 }), i(e.styleFilePath, e.styleFileContent), u(e.exampleDirPath, { recursive: !0 }), i(e.exampleFilePath, e.exampleFileContent), o(e.componentEntryFilePath) || i(e.componentEntryFilePath, ""), F(
    e.componentEntryFilePath,
    e.componentEntryFileAddContent
  ), o(e.typeEntryFilePath) || i(e.typeEntryFilePath, ""), F(e.typeEntryFilePath, e.typeEntryFileAddContent), o(e.styleEntryFilePath) || i(e.styleEntryFilePath, ""), F(e.styleEntryFilePath, e.styleEntryFileAddContent), o(e.styleVarFilePath) || i(e.styleVarFilePath, ""), F(e.styleVarFilePath, e.styleVarFileAddContent), o(e.exampleEntryFilePath) || i(e.exampleEntryFilePath, ""), F(e.exampleEntryFilePath, e.exampleEntryFileAddContent), console.log(m.green("创建成功"));
}, B = async ({
  configInfo: n,
  src: r
}) => {
  const l = _(n, "component.entryPath"), a = N(l)({
    src: r
  }), p = q({
    src: r,
    entryAbsoluteSrc: g(d, a),
    entryTemplate: n.component.entryTemplate
  }).map((s) => ({ title: s, value: s })), { name: e } = await c({
    type: "select",
    name: "name",
    message: "请选择要删除的组件",
    choices: p
  });
  if (console.log("name:", e), !e)
    throw new Error("组件名称不能为空");
  const y = C({
    name: e
  });
  console.log(y);
  const t = D(
    n,
    {
      ...y,
      rootPath: d
    },
    [
      "component.dir",
      "component.templateFilePath",
      "component.fileName",
      "component.entryTemplate",
      "component.entryPath",
      "type.dir",
      "type.templateFilePath",
      "type.fileName",
      "type.entryTemplate",
      "type.entryPath",
      "style.dir",
      "style.templateFilePath",
      "style.fileName",
      "style.varTemplate",
      "style.varPath",
      "style.entryTemplate",
      "style.entryPath",
      "example.dir",
      "example.templateFilePath",
      "example.fileName",
      "example.entryTemplate",
      "example.entryPath"
    ]
  );
  console.log(t), o(t.componentFilePath) || console.log(m.red("组件不存在")), o(t.typeFilePath) || console.log(m.red("类型不存在")), o(t.styleFilePath) || console.log(m.red("样式不存在")), o(t.exampleFilePath) || console.log(m.red("示例不存在"));
  const { delComponent: E } = await c({
    type: "confirm",
    name: "delComponent",
    message: `确认删除${t.componentDirPath}吗`
  });
  if (!E)
    throw new Error("取消删除");
  const { delType: f } = await c({
    type: "confirm",
    name: "delType",
    message: `确认删除${t.typeFilePath}吗`
  });
  if (!f)
    throw new Error("取消删除");
  const { delStyle: h } = await c({
    type: "confirm",
    name: "delStyle",
    message: `确认删除${t.styleFilePath}吗`
  });
  if (!h)
    throw new Error("取消删除");
  const { delExample: w } = await c({
    type: "confirm",
    name: "delExample",
    message: `确认删除${t.exampleDirPath}吗`
  });
  if (!w)
    throw new Error("取消删除");
  if (x(t.componentDirPath, { recursive: !0, force: !0 }), x(t.typeFilePath), x(t.styleFilePath), x(t.exampleDirPath, { recursive: !0, force: !0 }), !o(t.componentEntryFilePath))
    console.log(m.red("组件入口不存在"));
  else {
    const s = P(t.componentEntryFilePath, "utf-8");
    i(
      t.componentEntryFilePath,
      s.replace(t.componentEntryFileAddContent, "")
    );
  }
  if (!o(t.typeEntryFilePath))
    console.log(m.red("类型入口不存在"));
  else {
    const s = P(t.typeEntryFilePath, "utf-8");
    i(
      t.typeEntryFilePath,
      s.replace(t.typeEntryFileAddContent, "")
    );
  }
  if (!o(t.styleEntryFilePath))
    console.log(m.red("样式入口不存在"));
  else {
    const s = P(t.styleEntryFilePath, "utf-8");
    i(
      t.styleEntryFilePath,
      s.replace(t.styleEntryFileAddContent, "")
    );
  }
  if (!o(t.styleVarFilePath))
    console.log(m.red("样式变量不存在"));
  else {
    const s = P(t.styleVarFilePath, "utf-8");
    i(
      t.styleVarFilePath,
      s.replace(t.styleVarFileAddContent, "")
    );
  }
  if (!o(t.exampleEntryFilePath))
    console.log(m.red("示例入口不存在"));
  else {
    const s = P(t.exampleEntryFilePath, "utf-8");
    i(
      t.exampleEntryFilePath,
      s.replace(t.exampleEntryFileAddContent, "")
    );
  }
  console.log(m.green("删除成功"));
}, te = async (n, r) => {
  const l = j(), a = await L(l);
  if (n === "add")
    await z({ argv: r, configInfo: l, src: a });
  else if (n === "remove")
    await B({ argv: r, configInfo: l, src: a });
  else
    throw new Error(`未知命令${n}`);
};
export {
  z as dealAdd,
  B as dealRemove,
  C as getAllNameInfo,
  te as handler
};
